diff -r 82fcd4bea972 NEWS.MCOA
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/NEWS.MCOA	Fri Jan 11 17:02:25 2008 +0100
@@ -0,0 +1,103 @@
+mipv6-daemon-umip-0.4-nepl-mcoa-20080108.patch
+News and Bugfixes list since mipv6-daemon-umip-0.3-nepl-mcoa-20071022.patch:
+
+* Updated code on top of the latest NEPL patch
+* No new features
+
+-----------------------------------------------------------------------
+mipv6-daemon-umip-0.4-nepl-mcoa-20071022.patch
+News and Bugfixes list since mipv6-daemon-umip-0.3-nepl-mcoa-20070613.patch:
+
+* Ported the code to UMIP 0.4. MCoA now runs on a 2.6.23 kernel, 
+  with an UMIP 0.4-based code for the userland.
+* Merged a fix to the proxy ND code for the HA (provided by 
+  Tobias HOF): the HA can now be used as legacy node on the 
+  Home Link (whereas it only worked as a gateway before).
+
+-----------------------------------------------------------------------
+mipv6-daemon-umip-0.3-nepl-mcoa-20070613.patch
+News and Bugfixes list since nemo-0.2-mcoa-beta2-20060630:
+
+* Ported the code to UMIP. MCoA now runs on a 2.6.21.3 kernel, 
+  with an UMIP-based code for the userland.
+* MCoA is now provided as a patch for the UMIP userland. 
+* The MCoA kernel patch is not needed anymore as it has been 
+  integrated in the mainline kernel.
+* No new functionnalities were added.
+
+-----------------------------------------------------------------------
+nemo-0.2-mcoa-beta3-20070118
+News and Bugfixes list since nemo-0.2-mcoa-beta2-20060630:
+
+* Base code:
+- Userland runs on a 2.6.16 kernel 
+- Upgraded fwmark patch for 2.6.16 kernel
+- MCoA userland code updated to nemo-20060725
+
+* Features:
+- New "Reliable" option that allows to use the BU as a 
+  heartbeat, and to automatically divert the traffic to 
+  another interface when one MR-HA path fails. 
+  See the manpage for details.
+- MPS/MPA can now be used with MCoA.
+- When handover occurs on an interface, forwarded traffic is now
+  blocked only for the interface performing the handover (whereas 
+  it was blocked globally before). The local traffic is also 
+  blocked for the interface that performs the handover, whereas 
+  it was blocked for the HoA interface before.
+- Merged patch to support HoA from MNP (for Mobile Routers)
+- Merged patch to support SIT tunnels
+- Merged patch to fix the MR behaviour in the Home Network
+  (the MR was not correctly forwarding packets from the MNNs)
+
+* Bugfixes:
+- The source address used to send the BU was sometimes outdated 
+  because the CoA was not correctly updated in the XFRM kernel 
+  state.
+- When packets originated from the MR were sent to the HA, the 
+  HA did not behave correctly because the source address of the 
+  packet may not match the one in the kernel XFRM state (that 
+  can only store one CoA). Thus the MR behaviour has been 
+  slightly changed to NOT use HAO dest. option when sending 
+  packet to the HA (This behaviour seems to respect the MIP6 
+  spec).
+- When packets originated from the MR were sent to the HA, and 
+  the MR handoffs, the HA still sent replied packets to the 
+  old CoA (using Routing Header Type 2). The HA now updates 
+  correctly the CoA stored in the kernel, but as the kernel 
+  can only store 1 CoA at a time, when the HA replies to the 
+  MR the path may be asymetric.
+- Added more checks in the configuration file grammar to 
+  avoid configuration errors for MCoA.
+- Solved infinite loop when interface was declared as Interface
+  but not in IfMultipleCoA.
+- Fixed some bugs when MCoA was disabled. It now works fine when 
+  not using MCoA. Interface prefence works also fine.
+- Fixed bugs when one entry was invalidated: rules are now 
+  correctly deleted.
+- Fixed bugs when choosing the default rule: invalid BULE are 
+  not looked up when searching for the default rule.
+- Improved the MR and HA behaviour regarding error management.
+
+
+-----------------------------------------------------------------------
+nemo-0.2-mcoa-beta2-20060630
+News and Bugfixes list since nemo-0.2-mcoa-beta1-20060531:
+
+- The MR was in some cases installing the same rules twice.
+- The MR had a problem to install some rules after recovering a failure.
+- The MR was stuck in an infinite loop at startup if MCoA was disabled
+- The MR could not clean properly tunnels if registration failed with HA
+- Policy issues when Returning home with a usual MR but using MCoA code
+- When the MR only have 1 active interface, handoff policy is different 
+  (rules not erased and dereg bu not send during handoff time)
+- When the MR receives a BAck without BID option, whereas it sent a BU
+  with a BID option, the MR only registers the prefered interface
+
+- If HA is not configured for MCoA, or MCoA not allowed for the HoA, then 
+  BU is accepted but no BID option is sent in BAck
+
+- Merged the OptimisticHandoff patch 
+- Merged the PPP patch
+
+-----------------------------------------------------------------------
diff -r 82fcd4bea972 include/netinet/ip6mh.h
--- a/include/netinet/ip6mh.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/include/netinet/ip6mh.h	Fri Jan 11 17:02:25 2008 +0100
@@ -146,6 +146,25 @@ struct ip6_mh_opt_mob_net_prefix {
 } __attribute__ ((packed));
 
 /*
+ * MCoA registration
+ * Binding Unique Identifier sub-option
+ */
+struct ip6_mh_opt_bid {
+	uint8_t ip6mobid_type;
+	uint8_t ip6mobid_len;
+	uint16_t ip6mobid_bid;
+	uint8_t ip6mobid_priority;
+	uint8_t ip6mobid_reserved;
+} __attribute__((packed));
+
+/* Binding Unique Identifier sub-option flags */
+#if BYTE_ORDER == BIG_ENDIAN
+#define IP6_OPT_BID_BULK		0x80  /*  Bulk Registration */
+#else	/* BYTE_ORDER == LITTLE_ENDIAN */
+#define IP6_OPT_BID_BULK		0x80  /*  Bulk Registration */
+#endif
+
+/*
  *     Mobility Header Message Types
  */
 #define IP6_MH_TYPE_BRR		0	/* Binding Refresh Request */
@@ -167,6 +186,7 @@ struct ip6_mh_opt_mob_net_prefix {
 #define IP6_MHOPT_NONCEID	0x04	/* Nonce Index */
 #define IP6_MHOPT_BAUTH		0x05	/* Binding Auth Data */
 #define IP6_MHOPT_MOB_NET_PRFX	0x06	/* Mobile Network Prefix */
+#define IP6_MHOPT_BID		0x07	/* Binding Unique Identifier */
 
 /*
  *    Status values accompanied with Mobility Binding Acknowledgement
@@ -191,6 +211,9 @@ struct ip6_mh_opt_mob_net_prefix {
 #define IP6_MH_BAS_INVAL_PRFX		141	/* Invalid Prefix */
 #define IP6_MH_BAS_NOT_AUTH_FOR_PRFX	142	/* Not Authorized for Prefix */
 #define IP6_MH_BAS_FWDING_FAILED	143	/* Forwarding Setup failed */
+#define IP6_MH_BAS_CONFLICT_BINDING	144	/* (TBD) MCoA Conflict between bindings */
+#define IP6_MH_BAS_MCOA_BULK_FAILED	145	/* (TBD) MCoA Bulk registration failed */
+
 /*
  *    Status values for the Binding Error mobility messages
  */
diff -r 82fcd4bea972 man/mip6d.conf.tmpl
--- a/man/mip6d.conf.tmpl	Fri Jan 11 16:55:08 2008 +0100
+++ b/man/mip6d.conf.tmpl	Fri Jan 11 17:02:25 2008 +0100
@@ -57,6 +57,9 @@ These options are used both in the Home 
 .BR "Interface " "name" " {"
 .BR "	MnIfPreference " "number" ";"
 .BR "	IfType " "CN | HA | MN" ";"
+.BR "	Bid " "number" ";"
+.BR "	BidPriority " "number" ";"
+.BR "	Reliable " "boolean" ";"
 .B }
 .fi
 
@@ -74,9 +77,10 @@ sets the interface preference value for 
 sets the interface preference value for an interface in a multi-homed
 Mobile Node.  The most preferred intefaces have preference 1, the
 second most preferred have 2, etc.  A preference of zero means the
-interface will not be used.
+interface will not be used. Do not use this option if you use the Multiple
+Care-of Address registration on your Mobile Node with this interface.
 
-Default: 5
+Default: 0
 
 .B IfType
 overrides the default node behavior for this interface. If a MN doesn't
@@ -86,6 +90,43 @@ Default: same as
 Default: same as
 .B NodeConfig
 
+.B Bid
+Sets the BID for this interface. The BID must be unique within all 
+interface definitions. This BID will be used as an Interface Identifier
+that the user can use for policy routing. If this option is defined, 
+also set the 
+.B BidPriority 
+option, and do not set the 
+.B MnIfPreference
+option.
+.B Bid 
+must be set between 1 and 251 (this is one of the current limitation 
+with this MCoA implementation).
+
+Default: 0 (no BID)
+
+.B BidPriority
+Sets the priority of the binding (the higher the better). When no 
+policies are define for some flows, the binding with the higher 
+preference is used. If this option is defined, do not set the 
+.B MnIfPreference
+option for this interface. 
+.B BidPriority 
+must be set between 1 and 255.
+
+Default: 0
+
+.B Reliable
+allows you to specify if the interface can be considered as reliable
+when using MCoA. If set to false, the traffic will be redirected to 
+another interface during the BU-BAck exchange. You can thus use the 
+BU as a heartbeat (by specifying a small
+.B MnMaxHaBindingLife
+), which can be pretty useful when one of your MR-HA path is not 
+reliable: traffic is redirected to the interface with the best 
+priority as long as no BAck is received.
+
+Default: true
 
 .TP
 .BR "UseMnHaIPsec " "boolean" ";"
@@ -191,6 +232,13 @@ Default: disabled;
 Default: disabled;
 
 .TP
+.BR "HaAcceptMCoAReg enabled | disabled"
+
+Indicates if the HA accepts Multiple Care-of Addresses registration.
+
+Default: disabled;
+
+.TP
 .BR "HaServedPrefix " "prefix/length" ";"
 
 Prefix is an IPv6 prefix and length is the prefix length. Defines the whole
@@ -199,7 +247,7 @@ Mobile Network Prefixes, instead of one 
 Mobile Network Prefixes, instead of one of the home link prefixes.
 
 .TP
-.BR "BindingAclPolicy " "address MNP list " "allow | deny"
+.BR "BindingAclPolicy " "address MNP list " "MCoAReg | NoMCoAReg " "allow | deny"
 
 Defines if a MN is allowed to register with the HA or not. The home address
 of the MN is given in the address field.  The mobile network prefixes
@@ -207,6 +255,12 @@ be an empty string or a comma separated 
 be an empty string or a comma separated list of network prefixes
 enclosed in braces, for example:
 .B "(3ffe:2620:6:3::/64, 3ffe:2620:6:4::/64)"
+The HA can forbid or allow the MN to register Multiple Care-of Addresses by
+setting the 
+.B NoMCoAReg 
+or 
+.B MCoAReg
+flag.
 
 .TP
 .BR "DefaultBindingAclPolicy allow | deny"
@@ -368,6 +422,31 @@ Default: disabled
 Default: disabled
 
 .TP
+.BR "RegMultipleCoA enabled | disabled"
+
+Defines if the Mobile Node should try to register Multiple Care-of 
+Addresses to its Home Agent. If enabled, use also the
+.B IfMultipleCoA
+option. If disabled, the node will only register one CoA at a time.
+
+Default: disabled;
+
+.TP
+.BR "IfMultipleCoA " "name1, name2, ..." ";"
+
+Defines the list of interfaces that will be used for Multiple Care-of 
+Addresses registration. This list must be composed with the names 
+(enclosed in double quotes) of the interfaces (eg. "eth1"), separated 
+with a coma. Each interface listed must have an 
+.B Interface
+definition properly filled with the Multiple Care-of Address options
+(
+.B Bid
+and 
+.B BidPriority
+).
+
+.TP
 The route optimization policies are of the form:
 
 .TP
@@ -389,7 +468,7 @@ matching this entry.
 .SH EXAMPLES
 
 .TP
-.BR "A NEMO Home Agent example:"
+.BR "A NEMO Home Agent example with MCoA support:"
 
 .nf
 NodeConfig HA;
@@ -397,18 +476,19 @@ Interface "eth0";
 Interface "eth0";
 
 HaAcceptMobRtr enabled;
+HaAcceptMCoAReg enabled;
 
 HaServedPrefix 3ffe:2620:6::/48;
 
 DefaultBindingAclPolicy deny;
-BindingAclPolicy 3ffe:2620:6:1::1234 (3ffe:2620:6:2::/64, 3ffe:2620:6:3::/64) allow;
+BindingAclPolicy 3ffe:2620:6:1::1234 (3ffe:2620:6:2::/64, 3ffe:2620:6:3::/64) MCoAReg allow;
 BindingAclPolicy 3ffe:2620:6:1::1235 allow;
 
 UseMnHaIPsec disabled;
 .fi
 
 .TP
-.BR "A NEMO Mobile Router example:"
+.BR "A NEMO Mobile Router example with MCoA support:"
 
 .nf
 NodeConfig MN;
@@ -416,7 +496,15 @@ DoRouteOptimizationCN disabled;
 DoRouteOptimizationCN disabled;
 DoRouteOptimizationMN disabled;
 
-Interface "eth0";
+Interface "eth0" {
+        Bid 111;
+        BidPriority 10;
+};
+
+Interface "eth1" {
+        Bid 222;
+        BidPriority 5;
+};
 
 MnRouterProbes 1;
 
@@ -426,6 +514,8 @@ MnHomeLink "eth0" {
         IsMobRtr enabled;
         HomeAgentAddress 3ffe:2620:6:1::1;
         HomeAddress 3ffe:2620:6:1::1234/64 (3ffe:2620:6:2::/64, 3ffe:2620:6:3::/64);
+        RegMultipleCoA enabled;
+        IfMultipleCoA "eth0", "eth1";
 }
 
 UseMnHaIPsec disabled;
diff -r 82fcd4bea972 src/bcache.c
--- a/src/bcache.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/bcache.c	Fri Jan 11 17:02:25 2008 +0100
@@ -48,6 +48,7 @@ static int bcache_count = 0;
 static int bcache_count = 0;
 
 pthread_rwlock_t bc_lock; /* Protects binding cache */
+int bce_next_entry(void *bce_v, void *next_bce_v);
 
 /** 
  * get_bcache_count - returns number of home and cache entries
@@ -90,6 +91,12 @@ void dump_bce(void *bce, void *os)
 	fprintf(out, " lifetime %ld\n ", e->lifetime.tv_sec);
 	fprintf(out, " seqno %d\n", e->seqno);
 
+ 	if (e->bid)
+ 		fprintf(out, " BID = %d, Priority = %d\n", 
+ 			e->bid, e->priority);
+ 	else
+ 		fprintf(out, " No BID assigned\n");
+ 
 	if (e->flags & IP6_MH_BA_MR) {
 		struct list_head *list;
 
@@ -201,6 +208,7 @@ void bcache_free(struct bcentry *bce)
  * @hinfo: home address info, optional if our_addr is present
  * @our_addr: local address (home address)
  * @peer_addr: address of CN
+ * @bid: BID of the bce
  *
  * Returns reference to non-null entry on success and null on failure.
  * If caller adjusts lifetime of entry, caller must call
@@ -208,7 +216,8 @@ void bcache_free(struct bcentry *bce)
  * call bcache_release_entry() after entry is not used anymore.
  **/
 struct bcentry *bcache_get(const struct in6_addr *our_addr,
-			   const struct in6_addr *peer_addr)
+ 			   const struct in6_addr *peer_addr,
+ 			   uint16_t bid)
 {
 	struct bcentry *bce;
 
@@ -216,7 +225,7 @@ struct bcentry *bcache_get(const struct 
 
 	pthread_rwlock_rdlock(&bc_lock);
 
-	bce = hash_get(&bc_hash, our_addr, peer_addr);
+	bce = hash_get(&bc_hash, our_addr, peer_addr, bid);
 
 	if (bce) 
 		pthread_rwlock_wrlock(&bce->lock);
@@ -240,16 +249,19 @@ void bcache_release_entry(struct bcentry
  * bce_type - get type of binding cache entry
  * @our_addr: our IPv6 address
  * @peer_addr: peer's IPv6 address
+ * @bid: BID of the bce
  *
  * Looks up entry from binding cache and returns its type.  If not
  * found, returns -%ENOENT.
  **/
-int bce_type(const struct in6_addr *our_addr, const struct in6_addr *peer_addr)
+int bce_type(const struct in6_addr *our_addr, 
+ 	     const struct in6_addr *peer_addr,
+ 	     uint16_t bid)
 {
         struct bcentry *bce;
         int type;
 
-        bce = bcache_get(our_addr, peer_addr);
+ 	bce = bcache_get(our_addr, peer_addr, bid);
 
         if (bce == NULL)
                 return -ENOENT;
@@ -264,7 +276,8 @@ static int __bcache_insert(struct bcentr
 {
 	int ret;
 
-	ret = hash_add(&bc_hash, bce, &bce->our_addr, &bce->peer_addr);
+	ret = hash_add(&bc_hash, bce, &bce->our_addr, 
+ 		       &bce->peer_addr, &bce->bid);
 	if (ret)
 		return ret;
 
@@ -282,7 +295,14 @@ static int __bcache_start(struct bcentry
 	      bce->type == BCE_HOMEREG ? bce->lifetime : tmp,
 	      expires);
 	add_task_abs(&expires, &bce->tqe, _expire); 
-	xfrm_add_bce(&bce->our_addr, &bce->peer_addr, &bce->coa, 0);
+ 	/* MCoA 
+ 	 * Due to the BID, the BC may have several entries with the 
+ 	 * same peer_addr. Thus we add states and policies only if 
+ 	 * there are no entries yet for the our_addr/peer_addr pair 
+ 	 * (see bce->xfrm_create).
+ 	 */
+ 	xfrm_add_bce(&bce->our_addr, &bce->peer_addr, &bce->coa, 0, 
+ 		     bce->xfrm_create);
 	return 0;
 }
 
@@ -350,22 +370,26 @@ int bcache_update_expire(struct bcentry 
 	}
 	tsadd(expires, bce->add_time, expires);
 	add_task_abs(&expires, &bce->tqe, _expire);	
-	xfrm_add_bce(&bce->our_addr, &bce->peer_addr, &bce->coa, 1);
+ 	xfrm_add_bce(&bce->our_addr, &bce->peer_addr, &bce->coa, 1, 0);
 
 	return 0;
 }
 
 /**
  * bcache_delete - deletes a bul entry
+ * If bid == 0, all entries that match our_addr/peer_addr are deleted
  **/
 void bcache_delete(const struct in6_addr *our_addr,
-		   const struct in6_addr *peer_addr)
+		   const struct in6_addr *peer_addr,
+		   uint16_t bid)
 {
 	struct bcentry *bce;
 	pthread_rwlock_wrlock(&bc_lock);
-	bce = hash_get(&bc_hash, our_addr, peer_addr);
-	if (bce)
-		bce_delete(bce, 0);
+ 	while ((bce = hash_get(&bc_hash, our_addr, peer_addr, bid))) {
+		if (bce)
+ 			bce_delete(bce, 0);
+ 	}
+ 
 	pthread_rwlock_unlock(&bc_lock);
 }
 
@@ -398,8 +422,27 @@ static void bce_delete(struct bcentry *b
 	pthread_rwlock_wrlock(&bce->lock);
 	if (bce->type != BCE_DAD) {
 		del_task(&bce->tqe);
-		if (bce->type != BCE_NONCE_BLOCK)
-			xfrm_del_bce(&bce->our_addr, &bce->peer_addr);
+ 		if (bce->type != BCE_NONCE_BLOCK) {
+			/* MCoA 
+			 * Due to the BID, the BC can have several entries 
+			 * with the same our_addr/peer_addr pair. We delete 
+			 * the xfrm data if we do not have any BCE for 
+			 * this peer_addr anymore, or we update it (we need 
+			 * to update the kernel's CoA to a valid one).
+			 */
+			if(mcoa_bce_count(&bce->peer_addr) == 1)
+				xfrm_del_bce(&bce->our_addr, &bce->peer_addr);
+			else {
+				struct bcentry *next = bce;
+				/* Look for another valid BCE */
+				bcache_iterate_in(&bce->peer_addr, 
+						  bce_next_entry, &next);
+				/* Replace the CoA */
+				xfrm_add_bce(&next->our_addr, 
+					     &next->peer_addr, 
+					     &next->coa, 1, 0);
+			}
+		}
 	}
 	if (bce->cleanup)
 		bce->cleanup(bce);
@@ -414,7 +457,7 @@ static void bce_delete(struct bcentry *b
 		}
 	}
 	bcache_count--;
-	hash_delete(&bc_hash, &bce->our_addr, &bce->peer_addr);
+	hash_delete(&bc_hash, &bce->our_addr, &bce->peer_addr, bce->bid);
 	pthread_rwlock_unlock(&bce->lock);
 	bcache_free(bce);
 }
@@ -458,3 +501,71 @@ int bcache_iterate(int (* func)(void *, 
 	pthread_rwlock_unlock(&bc_lock);
 	return err;
 }
+
+/**
+ * bcache_iterate_in - apply function to every BC entry that match peer_addr
+ * @peer_addr: the peer_addr of the hash
+ * @func: function to apply
+ * @arg: extra data for @func
+ *
+ * Iterates through binding cache, calling @func for each entry that 
+ * match peer_addr. Extra data may be passed to @func in @arg.  @func 
+ * takes a bcentry as its first argument and @arg as second argument.
+ *
+ * Be sure that bc_lock is locked before using this function, and 
+ * unlocked after using it.
+ **/
+int bcache_iterate_in(const struct in6_addr *peer_addr, 
+ 		      int (* func)(void *, void *), 
+ 		      void *arg)
+{
+	int err;
+	err = hash_iterate_in(&bc_hash, peer_addr, func, arg);
+	return err;	
+}
+
+int bce_highest_priority(void *bce_v, void *best_bce_v)
+{
+	struct bcentry *bce = bce_v;
+	struct bcentry **best_bce = best_bce_v;
+	
+	assert(bce);
+	assert(best_bce);
+
+	if (!(*best_bce) || (bce->priority > (*best_bce)->priority))
+		(*best_bce) = bce;
+
+	return 0;
+}
+
+int bce_next_entry(void *bce_v, void *next_bce_v)
+{
+	struct bcentry *bce = bce_v;
+	struct bcentry **next_bce = next_bce_v;
+	
+	assert(bce);
+	assert(next_bce);
+	
+	if (bce->bid != (*next_bce)->bid) {
+		(*next_bce) = bce;
+		return 1;
+	}
+	
+	return 0;
+}
+
+int mcoa_bce_inc_counter(void *bule_v, void *counter_v)
+{
+	int *counter = counter_v;
+	(*counter)++;
+	return 0;
+}
+
+int mcoa_bce_count(const struct in6_addr *peer_addr)
+{
+	int count = 0;
+	bcache_iterate_in(peer_addr, mcoa_bce_inc_counter, &count);
+
+	return count;
+}
+
diff -r 82fcd4bea972 src/bcache.h
--- a/src/bcache.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/bcache.h	Fri Jan 11 17:02:25 2008 +0100
@@ -20,6 +20,12 @@ struct bcentry {
 	uint16_t nonce_hoa;
 	uint16_t type;     		/* Entry type */
 	uint16_t nemo_type;    		/* NEMO registration type */
+	uint16_t bid; 			/* MCoA: Binding Identifier */
+	uint8_t priority;		/* MCoA: BID priority */
+	int table;			/* MCoA: Table id to where are stored
+					   the routes */
+	int xfrm_create;		/* MCoA: If xfrm policies/states must
+					   be created */
 	int unreach;			/* ICMP dest unreach count */
 	int tunnel;			/* Tunnel interface index */
 	int link;			/* Home link interface index */
@@ -48,12 +54,16 @@ struct bcentry {
 #define BCE_NEMO_IMPLICIT 2
 #define BCE_NEMO_DYNAMIC 3
 
+#define BCE_TABLE_MIN 1
+#define BCE_TABLE_MAX 251
+
 struct bcentry *bcache_alloc(int type);
 
 void bcache_free(struct bcentry *bce);
 
 struct bcentry *bcache_get(const struct in6_addr *our_addr,
-			   const struct in6_addr *peer_addr);
+			   const struct in6_addr *peer_addr,
+			   uint16_t bid);
 
 int bcache_add(struct bcentry *bce);
 
@@ -63,28 +73,37 @@ int bcache_update_expire(struct bcentry 
 int bcache_update_expire(struct bcentry *bce);
 
 void bcache_delete(const struct in6_addr *our_addr,
-		   const struct in6_addr *peer_addr);
+		   const struct in6_addr *peer_addr,
+		   uint16_t bid);
 
 int bcache_init(void);
 void bcache_flush(void);
 void bcache_cleanup(void);
 
 int bcache_iterate(int (* func)(void *, void *), void *arg);
+int bcache_iterate_in(const struct in6_addr *peer_addr, 
+		      int (* func)(void *, void *), 
+		      void *arg);
 
 void bcache_release_entry(struct bcentry *bce);
 
 int bce_type(const struct in6_addr *our_addr,
-	     const struct in6_addr *peer_addr);
+	     const struct in6_addr *peer_addr,
+	     uint16_t bid);
 
 static inline int bce_exists(const struct in6_addr *our_addr,
-			     const struct in6_addr *peer_addr)
+			     const struct in6_addr *peer_addr,
+			     uint16_t bid)
 {
-	return bce_type(our_addr, peer_addr) >= BCE_NONCE_BLOCK;
+	return bce_type(our_addr, peer_addr, bid) >= BCE_NONCE_BLOCK;
 }
+
+int bce_highest_priority(void *bce_v, void *best_bce_v);
 
 void dump_bce(void *bce, void *os);
 
 int get_bcache_count(int type);
+int mcoa_bce_count(const struct in6_addr *peer_addr);
 
 extern pthread_rwlock_t bc_lock; /* Protects binding cache */
 
diff -r 82fcd4bea972 src/bul.c
--- a/src/bul.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/bul.c	Fri Jan 11 17:02:25 2008 +0100
@@ -38,6 +38,8 @@
 #include "xfrm.h"
 #include "debug.h"
 #include "retrout.h"
+#include "tunnelctl.h"
+#include "rtnl.h"
 #ifdef ENABLE_VT
 #include "vt.h"
 #endif
@@ -55,7 +57,8 @@ static struct hash bul_hash;
 static struct hash bul_hash;
 
 struct bulentry *create_bule(const struct in6_addr *hoa,
-			     const struct in6_addr *cn_addr)
+			     const struct in6_addr *cn_addr, 
+			     u_int16_t bid)
 {
 	struct bulentry *bule;
 	if ((bule = malloc(sizeof(*bule))) != NULL) {
@@ -63,6 +66,11 @@ struct bulentry *create_bule(const struc
 		bule->hoa = *hoa;
 		bule->last_coa = *hoa;
 		bule->peer_addr = *cn_addr;
+		bule->bid = bid;
+		bule->if_tunnel = 0;
+		bule->rules = 0;
+		bule->home_block = 0;
+		bule->mcoa_dereg = 1;
 		INIT_LIST_HEAD(&bule->tqe.list);
 		bule->seq = random();
 	}
@@ -97,6 +105,11 @@ void dump_bule(void *bule, void *os)
 		NIP6ADDR(&e->peer_addr));
 	fprintf(out, " lifetime = %ld, ", e->lifetime.tv_sec);
 	fprintf(out, " delay = %ld\n", tstomsec(e->delay));
+	if (e->bid)
+		fprintf(out, " BID = %d, Priority = %d\n", 
+			e->bid, e->priority);
+	else
+		fprintf(out, " No BID assigned\n");	
 	fprintf(out, " flags: ");
 	if (e->flags & IP6_MH_BU_HOME)
 		fprintf(out, "IP6_MH_BU_HOME ");
@@ -118,21 +131,23 @@ void dump_bule(void *bule, void *os)
  * @hinfo: home address info, optional if our_addr is present
  * @our_addr: local address (home address)
  * @peer_addr: address of CN
+ * @bid: Binding Unique Identifier
  *
  * Returns non-null entry on success and null on failure. Caller must
  * call del_task and add_task, if lifetime of the entry is changed.
  **/
 struct bulentry *bul_get(struct home_addr_info *hinfo,
 			 const struct in6_addr *our_addr,
-			 const struct in6_addr *peer_addr)
+			 const struct in6_addr *peer_addr,
+			 u_int16_t bid)
 {
 	struct bulentry *bule;
 
 	assert(hinfo || our_addr);
 
 	if (hinfo)
-		bule = hash_get(&hinfo->bul, NULL, peer_addr);
-	else bule = hash_get(&bul_hash, our_addr, peer_addr);
+		bule = hash_get(&hinfo->bul, NULL, peer_addr, bid);
+	else bule = hash_get(&bul_hash, our_addr, peer_addr, bid);
 	return bule;
 }
 
@@ -175,9 +190,11 @@ int bul_add(struct bulentry *bule)
 
 	assert(bule && tsisset(bule->lifetime) && hai);
 	
-	if ((ret = hash_add(&bul_hash, bule, &bule->hoa, &bule->peer_addr)) < 0)
+	if ((ret = hash_add(&bul_hash, bule, &bule->hoa, &bule->peer_addr, 
+			    &bule->bid)) < 0)
 		return ret;
-	if ((ret = hash_add(&hai->bul, bule, NULL, &bule->peer_addr)) < 0)
+	if ((ret = hash_add(&hai->bul, bule, NULL, &bule->peer_addr,
+			    &bule->bid)) < 0)
 		goto bul_free;
 
 	clock_gettime(CLOCK_REALTIME, &bule->lastsent);
@@ -197,9 +214,9 @@ int bul_add(struct bulentry *bule)
 	add_task_abs(&timer_expire, &bule->tqe, bule->callback);
 	return 0;
 home_bul_free:
-	hash_delete(&hai->bul, &bule->hoa, &bule->peer_addr);
+	hash_delete(&hai->bul, &bule->hoa, &bule->peer_addr, bule->bid);
 bul_free:
-	hash_delete(&bul_hash, &bule->hoa, &bule->peer_addr);
+	hash_delete(&bul_hash, &bule->hoa, &bule->peer_addr, bule->bid);
 	return ret; 
 }
 
@@ -209,8 +226,8 @@ void bul_delete(struct bulentry *bule)
 	struct home_addr_info *hai = bule->home;
 
 	del_task(&bule->tqe);
-	hash_delete(&bul_hash, &bule->hoa, &bule->peer_addr);
-	hash_delete(&hai->bul, NULL, &bule->peer_addr);
+	hash_delete(&bul_hash, &bule->hoa, &bule->peer_addr, bule->bid);
+	hash_delete(&hai->bul, NULL, &bule->peer_addr, bule->bid);
 
 	if (!IN6_ARE_ADDR_EQUAL(&bule->hoa, &bule->coa)) {
 		bule->last_coa = bule->coa;
@@ -222,6 +239,7 @@ void bul_delete(struct bulentry *bule)
 		if (!(bule->flags & IP6_MH_BU_HOME))
 			mn_rr_delete_bule(bule);
 	}
+
 	if (bule->flags & IP6_MH_BU_HOME) {
 		if (bule->type == UNREACH_ENTRY) {
 			pthread_mutex_lock(&hai->ha_list.c_lock);
@@ -232,16 +250,28 @@ void bul_delete(struct bulentry *bule)
 		} else {
 			if (hai->home_block & HOME_LINK_BLOCK)
 				xfrm_unblock_link(hai);
+			if (bule->home_block & HOME_LINK_BLOCK)
+				xfrm_unblock_bule_link(bule);
 			if (hai->home_block & HOME_ADDR_BLOCK)
 				xfrm_unblock_hoa(hai);
 			if (hai->home_block & NEMO_RA_BLOCK)
 				xfrm_unblock_ra(hai);
 			if (hai->home_block & NEMO_FWD_BLOCK)
 				xfrm_unblock_fwd(hai);
+			if (bule->home_block & NEMO_FWD_BLOCK)
+				bule_unblock_fwd(bule);
 		}
 	}
 	while (bule->ext_cleanup)
 		bule->ext_cleanup(bule);
+
+	/* MCoA
+	 * If MCoA is used, the tunnel related to this BULE
+	 * has to be deleted.
+	 */
+	if (bule->home->reg_mcoa && bule->type != NON_MIP_CN_ENTRY)
+		tunnel_del(bule->if_tunnel, NULL, NULL);
+
 	dbg("Deleting bule\n");
 	dbg_func(bule, dump_bule);
 	free_bule(bule);
@@ -312,3 +342,129 @@ int bul_iterate(struct hash *h, int (* f
 	struct hash *tmp = h ? h : &bul_hash;
 	return hash_iterate(tmp, func, arg);
 }
+
+/**
+ * bul_iterate_in - apply function to every BUL entry that match peer_addr
+ * @peer_addr: the peer_addr of the hash
+ * @func: function to apply
+ * @arg: extra data for @func
+ *
+ * Iterates through binding update list, calling @func for each entry that 
+ * match peer_addr. Extra data may be passed to @func in @arg.  @func 
+ * takes a BUL entry as its first argument and @arg as second argument.
+ **/
+int bul_iterate_in(struct in6_addr *peer_addr, 
+		   int (* func)(void *, void *), 
+		   void *arg)
+{
+	return hash_iterate_in(&bul_hash, peer_addr, func, arg);
+}
+
+int bul_highest_priority(void *bule_v, void *best_bule_v)
+{
+	struct bulentry *bule = bule_v;
+	struct bulentry **best_bule = best_bule_v;
+	
+	assert(bule);
+	assert(best_bule);
+	
+	if(bule->type == NON_MIP_CN_ENTRY ||
+	   bule->type == UNREACH_ENTRY)
+		return 0;
+
+	if (!(*best_bule)
+	    || (bule->priority > (*best_bule)->priority
+		&& bule->rules))
+		(*best_bule) = bule;
+	
+	return 0;
+}
+
+int mcoa_bule_inc_counter(void *bule_v, void *counter_v)
+{
+	struct bulentry *bule = bule_v;
+	int *counter = counter_v;
+	assert(counter);
+	
+	if(bule->type != NON_MIP_CN_ENTRY)
+		(*counter)++;
+	return 0;
+}
+
+/**
+ * mcoa_bule_count - count the number of entry (!NON_MIP_CN_ENTRY) 
+ * with the same peer_addr.
+ * @bule: the bule where to pick up the peer address
+ **/
+
+int mcoa_bule_count(struct bulentry *bule)
+{
+	int count = 0;
+	assert(bule);
+	bul_iterate_in(&bule->peer_addr, mcoa_bule_inc_counter, &count);
+	return count;
+}
+
+
+int mcoa_bule_setdereg(void *bule_v, void *dereg_v)
+{
+	int *dereg = dereg_v;
+	struct bulentry *bule = bule_v;
+	
+	assert(dereg);
+	bule->mcoa_dereg = *(dereg);
+	return 0;
+}
+
+/**
+ * mcoa_bule_dereg - Set the BULE mcoa_dereg flag to value for 
+ * all entries that match bule->peer_addr.
+ * @bule: the bule where to pick up the peer address
+ * @value: the value to set
+ **/
+int mcoa_bule_dereg(struct bulentry *bule, int value)
+{
+	bul_iterate_in(&bule->peer_addr, mcoa_bule_setdereg, &value);
+	return 0;
+}
+
+/**
+ * bule_block_fwd - Block forwarding for all MNPs 
+ * via the fwmark (BID) of the bule
+ * @bule: the bule
+ */
+void bule_block_fwd(struct bulentry *bule)
+{
+	struct list_head *l;
+	if (!bule->rules)
+		return;
+	bule->home_block |= NEMO_FWD_BLOCK; 
+	list_for_each(l, &bule->home->mob_net_prefixes) {
+		struct prefix_list_entry *p = NULL;
+		p = list_entry(l, struct prefix_list_entry, list);
+		rule_add(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK,
+			/*fwmark*/ bule->bid, RTN_BLACKHOLE,
+			&p->ple_prefix, p->ple_plen,
+			&in6addr_any, 0, 0);
+	}
+}
+
+/**
+ * bule_unblock_fwd - unblock forwarding for all MNPs 
+ * via the fwmark (BID) of the bule
+ * @bule: the bule
+ */
+void bule_unblock_fwd(struct bulentry *bule)
+{
+	struct list_head *l;
+	bule->home_block &= ~NEMO_FWD_BLOCK;
+	list_for_each(l, &bule->home->mob_net_prefixes) {
+		struct prefix_list_entry *p = NULL;
+		p = list_entry(l, struct prefix_list_entry, list);
+		rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_BLOCK, 
+			/*fwmark*/ bule->bid, RTN_BLACKHOLE,  
+			&p->ple_prefix, p->ple_plen,    
+			&in6addr_any, 0, 0);
+	}               
+}
+
